﻿//+--------------------------------------------------------------------------+
//|                                                                          |
//|                                 SPLASH                                   |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                           copyright (c) 2006                             |
//|                                                                          |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//|                          www.zapsolution.com                             |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 11-23-2006 (MM-DD-YYYY)            |
//|                        Last revised : 11-23-2006 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Win32;
using Gplus;

using System.Runtime.InteropServices;

namespace Splash
{
    public partial class SPLASH_Form : Form
    {
        public unsafe SPLASH_Form()
        {
            InitializeComponent();

            string ImgFile = Api.ExePath() + "p_image.png";
            string MskFile = Api.ExePath() + "p_mask.png";
            int imgW = 0, imgH = 0;
            GP.GetImageSizeFromFile(ImgFile, ref imgW, ref imgH);
            if ((imgW == 0) || (imgH == 0))
            { Close(); }
            else
            {
                int X = (Screen.PrimaryScreen.Bounds.Width - imgW) / 2;
                int Y = (Screen.PrimaryScreen.Bounds.Height - imgH) / 2;

                // Perform screen shot
                Bitmap Bkg = new Bitmap(imgW, imgH);
                Graphics g = Graphics.FromImage(Bkg);
                IntPtr hDCDest = g.GetHdc();
                IntPtr hDeskTop = Api.GetDesktopWindow();
                int hDCSrce = Api.GetWindowDC(hDeskTop);
                Api.BitBlt((int)hDCDest, 0, 0, imgW, imgH, (int)hDCSrce, X, Y, Api.SRCCOPY);
                Api.ReleaseDC(hDeskTop, hDCSrce);
                g.ReleaseHdc(hDCDest);
                g.Dispose();

                // Load Image + Mask
                Bitmap Img = new Bitmap(ImgFile);
                Bitmap Msk = new Bitmap(MskFile);
                // Perform progressive Alphablending
                Bitmap Mix = GP.Alphablend(Img, Msk);
                Rectangle destRect = new Rectangle(0, 0, imgW, imgH);
                Rectangle srceRect = new Rectangle(0, 0, imgW, imgH);
                g = Graphics.FromImage(Bkg);
                g.DrawImage(Mix, destRect, srceRect, GraphicsUnit.Pixel);
                g.Dispose();

                // Use result as our form background
                this.BackgroundImage = Bkg;

                Api.MoveWindow(this.Handle, X, Y, imgW, imgH, false);

            }
        }

        private void BTN_Close_Click(object sender, EventArgs e)
        {
            Close();
        }

    }
}